=== debian/changelog ===
rocm-smi-lib (5.7.0-1ubuntu1) oracular; urgency=medium

  * Fix FTBFS with GCC 14, see #1075450

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 26 Aug 2024 17:00:35 +0000

rocm-smi-lib (5.7.0-1) unstable; urgency=medium

  * Migrate rocm-smi-lib 5.7 from experimental to unstable.
  * d/t/control: add test `rocm-smi -S`.
    Leverage ROCm CI to check whether and where bug #1031121 appears.
  * d/control: librocm-smi-dev recommends liboam-dev.
    Work around bug #1022797 until a better approach is applied.

 -- Étienne Mollier <emollier@debian.org>  Sun, 04 Feb 2024 16:47:34 +0100

rocm-smi-lib (5.7.0-0+exp1) experimental; urgency=medium

  [ Étienne Mollier ]
  * New upstream version 5.7.0
  * 0003-clean-amd64-flags.patch: refresh.
  * 0004-gcc-12.patch: delete: applied upstream.
  * 0006-CMakeLists.txt-do-not-enforce-fPIE.patch: refresh.
  * 0007-rocm_smi64-soversion.patch: new: enforce rocm_smi64 soversion to 1.
    This is for consistency with previous versions of the librocm-smi64-1
    package in Debian, but upstream soversion is at 5 at least since ROCm
    5.2.3.  Synchronization with upstream's soversion is to be brought on
    next bump, probably for ROCm 6.
  * d/*.install: deploy libraries in multiarchitecture locations.
  * d/lib*1.install: make libraries copies more targeted.
    This prevents copying over the librocm_smi64.so.5 which has a delta
    compared to Debian's SOVERSION.
  * d/librocm-smi-dev.docs: delete.
    The corresponding documentation is already deployed somehow.
  * d/*.symbols*: update symbols tables.
    There is a notable signature change in shared_mutex_init, however this
    symbol is not part of rocm-smi-lib API, as it is leaked from third
    party headers, and reverse dependencies should not make use of it.  In
    the eventuality that reverse dependencies to get broken by this
    update, an SOVERSION bump would probably have to be considered.

  [ Mo Zhou ]
  * Deprecate the rsmiBinding merger patches as they are already outdated.
    Instead, we will symlink the rsmiBindings.py to the standard python
    library path, so that it can be imported by all other python scripts.
    + Two autopkgtest cases are also added to ensure its correctness.

  [ Étienne Mollier ]
  * d/copyright: undocument files removed.
  * 0008-typo.patch: new: fix typos caught by lintian.
  * d/copyright: bump copyright years.
  * d/control: ensure librocm-smi64-1 and rocm-smi version consistency.
  * d/rocm-smi.1: refresh with manual adjustments on top of help2man.
  * d/salsa-ci.yml: disable test on i386.
    There is a bad interaction between the package and salsa CI for the
    i386 package build.

 -- Étienne Mollier <emollier@debian.org>  Tue, 09 Jan 2024 19:44:59 +0100

rocm-smi-lib (5.2.3-3) unstable; urgency=medium

  * 0006-CMakeLists.txt-do-not-enforce-fPIE.patch: new.
    This patch fixes both a link failure observed on amd64 when lto is
    enabled and hppa, which had very similar symptom reported in the bug
    tracker. (Closes: #1015653, #1030876)
  * d/*.symbols*: update symbols table for gcc 13. (Closes: #1037846, #1042134)
  * d/clean: remove build remnants.
  * d/control: declare compliance to standards version 4.6.2.

 -- Étienne Mollier <emollier@debian.org>  Sun, 27 Aug 2023 12:58:35 +0200
